import 'package:equatable/equatable.dart';
import 'package:flutter_riverpod/flutter_riverpod.dart';
import '../../models/response_search_pengantaran_hasil_model.dart';
import '../../provider/dio_provider.dart';
import '../../repository/base_repository.dart';
import '../../repository/pengantaran_hasil_dokter_repository.dart';

// 3. state provider
final pengantaranHasilDokterSearch = StateNotifierProvider<PengantaranhasilDokterNotifier, PengantaranhasilDokterState>(
    (ref) => PengantaranhasilDokterNotifier(ref: ref));

// 2. notifier
class PengantaranhasilDokterNotifier extends StateNotifier<PengantaranhasilDokterState> {
  final Ref ref;
  PengantaranhasilDokterNotifier({required this.ref}) : super(PengantaranhasilDokterStateInit());
  void loadListNoDokterPengantaranHasilDokter(
      {
        required String search
      }) async {
    try {
      state = PengantaranhasilDokterStateLoading();
      final resp = await PengantaranHasilDokterRepository(dio: ref.read(dioProvider))
          .loadListNoDokterPengantaranHasilDokter(search: search);

      state = PengantaranhasilDokterStateDone(model: resp);
    } catch (e) {
      if (e is BaseRepositoryException) {
        state = PengantaranhasilDokterStateError(message: e.message ?? "");
      } else {
        state = PengantaranhasilDokterStateError(message: e.toString());
      }
    }
  }
}

// 1. state
abstract class PengantaranhasilDokterState extends Equatable {
  final DateTime date;
  const PengantaranhasilDokterState(this.date);
  @override
  List<Object?> get props => [date];
}

class PengantaranhasilDokterStateInit extends PengantaranhasilDokterState {
  PengantaranhasilDokterStateInit() : super(DateTime.now());
}

class PengantaranhasilDokterStateLoading extends PengantaranhasilDokterState {
  PengantaranhasilDokterStateLoading() : super(DateTime.now());
}

class PengantaranhasilDokterStateError extends PengantaranhasilDokterState {
  final String? message;
  PengantaranhasilDokterStateError({
    required this.message,
  }) : super(DateTime.now());
}

class PengantaranhasilDokterStateDone extends PengantaranhasilDokterState {
  final List<ResponseSearchPengantaranHasilModel> model;
  PengantaranhasilDokterStateDone({
    required this.model,
  }) : super(DateTime.now());
}
